package com.engine.organization.web;

import com.alibaba.fastjson.JSON;
import com.engine.common.util.ParamUtil;
import com.engine.common.util.ServiceUtil;
import com.engine.organization.entity.scheme.dto.SchemeListDTO;
import com.engine.organization.entity.scheme.param.SchemeSearchParam;
import com.engine.organization.service.SchemeService;
import com.engine.organization.service.impl.SchemeServiceImpl;
import com.engine.organization.util.ResponseResult;
import com.engine.organization.util.page.PageInfo;
import com.engine.organization.util.response.ReturnResult;
import com.engine.organization.wrapper.SchemeWrapper;
import io.swagger.v3.oas.annotations.parameters.RequestBody;
import weaver.hrm.HrmUserVarify;
import weaver.hrm.User;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.ws.rs.*;
import javax.ws.rs.core.Context;
import javax.ws.rs.core.MediaType;
import java.util.Map;

public class SchemeController {

    private SchemeService getSchemeService(User user) {
        return ServiceUtil.getService(SchemeServiceImpl.class, user);
    }

    public SchemeWrapper getSchemeWrapper(User user) {
        return ServiceUtil.getService(SchemeWrapper.class, user);
    }


    /**
     * 获取list列表
     * @param request
     * @param response
     * @param searchCondition
     * @return
     */
    @GET
    @Path("/getTable")
    @Produces(MediaType.APPLICATION_JSON)
    public String getTable(@Context HttpServletRequest request, @Context HttpServletResponse response,
                           @QueryParam("searchCondition") String searchCondition) {
        User user = HrmUserVarify.getUser(request, response);
        Map<String, Object> map = ParamUtil.request2Map(request);
        return ResponseResult.run(getSchemeService(user)::listPage, map);
    }

    /**
     * 添加职等职级信息
     * @param request
     * @param response
     * @return
     */
    @POST
    @Path("/save")
    @Produces(MediaType.APPLICATION_JSON)
    public String saveFrom(@Context HttpServletRequest request, @Context HttpServletResponse response) {
        User user = HrmUserVarify.getUser(request, response);
        return ResponseResult.run(getSchemeService(user)::save, ParamUtil.request2Map(request));

    }

}
